package cn.efunbox.manage.base.service.impl;

import cn.efunbox.manage.base.entity.CostType;
import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.base.repository.CostTypeRepository;
import cn.efunbox.manage.base.service.CostTypeService;
import cn.efunbox.manage.common.result.ApiCode;
import cn.efunbox.manage.common.result.ApiResult;
import com.sun.xml.internal.rngom.parse.host.Base;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

/**
 * CostTypeServiceImpl
 * Created by wangys on 2019/03/08
 */
@Service
public class CostTypeServiceImpl implements CostTypeService {

    @Autowired
    CostTypeRepository costTypeRepository;

    @Override
    public ApiResult list(CostType costType) {
        List<CostType> costTypes = costTypeRepository.find(costType);
        if(Objects.nonNull(costTypes)){
            return ApiResult.ok(costTypes);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult save(CostType costType) {
        if(costType == null){
            return ApiResult.error(ApiCode.PARAMETER_ERROR);
        }
        costType = costTypeRepository.save(costType);
        if(Objects.nonNull(costType)){
            return ApiResult.ok(costType);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult update(CostType costType) {
        if(costType == null){
            return ApiResult.error(ApiCode.PARAMETER_ERROR);
        }
        costType = costTypeRepository.update(costType);
        if(Objects.nonNull(costType)){
            return ApiResult.ok(costType);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult getById(Long costTypeId) {
        if(Objects.isNull(costTypeId)){
            return ApiResult.error(ApiCode.PARAMETER_ERROR);
        }
        CostType costType = costTypeRepository.find(costTypeId);
        if(costType ==null){
            return ApiResult.error(ApiCode.NOT_FOUND);
        }
        return ApiResult.ok(costType);
    }

    @Override
    public ApiResult select(CostType costType) {
        return ApiResult.ok(costTypeRepository.findByStatusOrderBySortDesc(BaseStatusEnum.NORMAL));
    }
}
