package cn.efunbox.manage.base.controller;

import cn.efunbox.manage.base.entity.Department;
import cn.efunbox.manage.base.entity.Manage;
import cn.efunbox.manage.base.service.DepartmentService;
import cn.efunbox.manage.base.service.ManageService;
import cn.efunbox.manage.common.result.ApiResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * ManageController
 * Created by wangys on 2019/03/08
 */
@RequestMapping("/manage")
@RestController
public class ManageController {

    @Autowired
    ManageService manageService;

    @Autowired
    DepartmentService departmentService;

    @GetMapping
    public ApiResult findManage(Manage manage){
        ApiResult<List<Department>> deptResult = departmentService.getDeptChild(manage.getDeptId() == null ? 0l : manage.getDeptId());
        List<Long> deptIds = new ArrayList<>();
        deptResult.getData().stream().forEach(department -> {
            deptIds.add(department.getId());
        });
        manage.setDeptIds(deptIds);
        return manageService.list(manage);
    }

    @PostMapping
    public ApiResult save(@RequestBody Manage manage){
        return manageService.save(manage);
    }

    @PutMapping
    public ApiResult update(@RequestBody Manage manage){
        return manageService.update(manage);
    }

    @GetMapping("/{id}")
    public ApiResult getManageById(@PathVariable(name = "id") Long manageId){
        return manageService.getById(manageId);
    }
}
